﻿package com.learningactionscript3.vehicles {

	import flash.display.MovieClip;
	import flash.events.Event;
	import com.learningactionscript3.accessories.soundsystems.IAudible;
	
	public class Vehicle extends MovieClip {

		private var _gasMileage:Number;
		private var _fuelAvailable:Number;
		private var _milesTraveled:Number = 0;
		private var _moving:Boolean;
		private var _soundSystem:IAudible;

		public function Vehicle(mpg:Number=21, fuel:Number=18.5) {
			_gasMileage = mpg;
			_fuelAvailable = fuel;
			this.addEventListener(Event.ENTER_FRAME, onLoop, false, 0, true);
		}
		
		private function onLoop(evt:Event):void {
			if (_moving) {
				_fuelAvailable--;
				_milesTraveled += _gasMileage;
				if (_fuelAvailable < 1) {
					this.removeEventListener(Event.ENTER_FRAME, onLoop);
				}
				trace(this, _milesTraveled, _fuelAvailable);
				this.x = _milesTraveled;
			}
		}
		
		public function useAccessory():void {
			trace(this, "turned on lights");
		}
		
		public function changeGear():void {
			trace(this, "changed gear");
		}
		
		public function go():void {
			_moving = true;
		}
		
		public function get gasMileage():Number {
			return _gasMileage;
		}
		
		public function set gasMileage(mpg:Number):void {
			_gasMileage = mpg;
		}
		
		public function get fuelAvailable():Number {
			return _fuelAvailable;
		}
		
		public function set fuelAvailable(fuel:Number):void {
			_fuelAvailable = fuel;
		}
		
		public function get milesTraveled():Number {
			return _milesTraveled;
		}
		
		public function get soundSystem():IAudible {
			return _soundSystem;
		}
		
		public function set soundSystem(device:IAudible):void {
			_soundSystem = device;
		}

	}
}