﻿package com.learningactionscript3.ui {

	import flash.display.Graphics;
	import flash.display.MovieClip;
	import flash.display.Shape;
	import flash.display.SimpleButton;
	import flash.text.TextField;
	import flash.text.TextFieldAutoSize;
	import fl.motion.Color;

	public class RoundRectButton extends MovieClip {

		private var _w:Number;
		private var _h:Number;
		private var _rad:Number;
		private var _linW:Number;
		private var _col:uint;
		private var _txt:String;
		private var _txtCol:uint;

		public function RoundRectButton(w:Number, h:Number,
										rad:Number, linW:Number,
										col:uint, txt:String,
										txtCol:uint) {
			_w = w;
			_h = h;
			_rad = rad;
			_linW = linW;
			_col = col;
			_txt = txt;
			_txtCol = txtCol;
			
			var btn:SimpleButton = createBtn();
			addChild(btn);
			var labl:TextField = createLabel();
			addChild(labl);
		}
		//create all button states
		private function createBtn():SimpleButton {
			var ovCol:uint = Color.interpolateColor(_col,
													0xFFFFFF,
													0.3);
			var dnCol:uint = Color.interpolateColor(_col,
													0x000000,
													0.3);
 			var btn:SimpleButton = new SimpleButton();
			btn.upState = createRoundRect(_col);
			btn.overState = createRoundRect(ovCol);
			btn.downState = createRoundRect(dnCol);
			btn.hitTestState = btn.upState;
			return btn;
		}
		
		private function createRoundRect(col:uint):Shape {
			var rRect:Shape = new Shape();
			var g:Graphics = rRect.graphics;
			g.lineStyle(_linW, _col);
			g.beginFill(col, 0.5);
			g.drawRoundRect(0, 0, _w, _h, _rad);
			g.endFill();
			return rRect;
		}
		
		private function createLabel():TextField {
			var txt:TextField = new TextField();
			txt.width = _w;
			txt.y = _h / 2 - 6;
			txt.autoSize = TextFieldAutoSize.CENTER;
			txt.textColor = _txtCol;
			txt.text = _txt;
			txt.mouseEnabled = false;
			
			return txt;
		}
	}
}