﻿package com.learningactionscript3.color {
	
	import flash.display.BitmapData;
	import flash.display.MovieClip;
	import flash.events.MouseEvent;
	import flash.text.TextField;
	import flash.text.TextFieldAutoSize;
	import flash.display.Graphics;
	import fl.motion.Color;
	import com.learningactionscript3.color.ColorPickerGraphics;
	
	public class ColorPickerCustom extends MovieClip {
		
		private var _pickerArt:ColorPickerGraphics;
		private var _bmd:BitmapData;
		private var _col:uint = 0x000000;
		private var _tf:TextField;
		private var _chip:MovieClip;
		//class constructor
		public function ColorPickerCustom() {
			_pickerArt = new ColorPickerGraphics();
			addChild(_pickerArt);
			_pickerArt.addEventListener(MouseEvent.CLICK,
										onClick, false, 0, true);

			_bmd = new BitmapData(_pickerArt.width,
								  _pickerArt.height);
			_bmd.draw(_pickerArt);

			_tf = new TextField();
			_tf.width = 100;
			_tf.height = 14;
			_tf.y = 100;
			_tf.text = "#000000";
			_tf.background = true;
			_tf.mouseEnabled = false;
			addChild(_tf);
			
			_chip = new MovieClip();
			var g:Graphics = _chip.graphics;
			g.beginFill(0x000000);
			g.drawRect(0, 0, 100, 14);
			g.endFill();
			_chip.y = 114;
			addChild(_chip);
			
			var border:MovieClip = new MovieClip();
			border.graphics.lineStyle(1, 0x000000);
			border.graphics.drawRect(0, 0, 100, 128);
			addChild(border);
		}
		//listener function
		private function onClick(evt:MouseEvent):void {
			_col = _bmd.getPixel(_pickerArt.mouseX,
								 _pickerArt.mouseY);
			_tf.text = prependZeros(_col);
			
			var col:Color = new Color();
			col.setTint(_col, 1);
			_chip.transform.colorTransform = col;
		}
		//getter for access to _col
		public function get color():uint {
			return _col;
		}
		//text formatting for hex string display in picker
		private function prependZeros(hex:uint):String {
			var zeros:String = "";
			var hexString = hex.toString(16).toUpperCase();
			var cnt:int = 6 - hexString.length;
			for (var i:int = 0; i < cnt; i++) {
				zeros += "0";
			}
			return "#" + zeros + hexString;
		}
	}
}