﻿package {

	import flash.display.MovieClip;
	import flash.events.Event;
	import flash.events.TextEvent;
	import flash.net.URLLoader;
	import flash.net.URLRequest;
	import flash.text.StyleSheet;
	import flash.text.TextField;
	import flash.text.TextFormat;
	
	public class LoadHTMLCSS_Example extends MovieClip {

		private var _cssFile:URLLoader;
		private var _htmlFile:URLLoader;
		private var _css:StyleSheet;
		private var _definitionField:TextField;
		//constructor
		public function LoadHTMLCSS_Example() {
			_cssFile = new URLLoader();
			_cssFile.addEventListener(Event.COMPLETE, onLoadCSS, 
									 false, 0, true);
			var req:URLRequest = new URLRequest("demo.css");
			_cssFile.load(req);
		}
		//loading style sheet
		private function onLoadCSS(evt:Event):void {
			_css = new StyleSheet();
			_css.parseCSS(evt.target.data);
			_htmlFile = new URLLoader();
			_htmlFile.addEventListener(Event.COMPLETE, onLoadHTML,
									   false, 0, true);
			var req:URLRequest = new URLRequest("demo.html");
			_htmlFile.load(req);
		}
		//loading html
		private function onLoadHTML(evt:Event):void {
			var htmlString:String = evt.target.data;
			
			var storyField:TextField = new TextField();
			storyField.x = storyField.y = 20;
			storyField.width = 500;
			storyField.height = 330;
			storyField.multiline = true;
			storyField.wordWrap = true;
			storyField.selectable = false;
			storyField.styleSheet = _css;
			storyField.htmlText = htmlString;
			storyField.addEventListener(TextEvent.LINK, 
										onTextEvent,
										false , 0, true);
			addChild(storyField);
			
			var definitionFormat:TextFormat = new TextFormat();
			definitionFormat.font = "_sans";
			definitionFormat.size = 12;
			definitionFormat.italic = true;
			
			_definitionField = new TextField();
			_definitionField.x = 20;
			_definitionField.y = 360;
			_definitionField.width = 500;
			_definitionField.height = 20;
			_definitionField.mouseEnabled = false;
			_definitionField.defaultTextFormat = definitionFormat;
			addChild(_definitionField);
			
			_cssFile.removeEventListener(Event.COMPLETE, 
										 onLoadCSS);
			_htmlFile.removeEventListener(Event.COMPLETE,
										  onLoadHTML);
		}
		
		private function onTextEvent(evt:TextEvent):void {
			_definitionField.text = evt.text;
		}
	}
}