﻿package  com.learningactionscript3.color {
	
	import flash.display.MovieClip;
	import flash.display.GradientType;
	import flash.geom.Matrix;
	import flash.display.Graphics;
	
	public class ColorPickerGraphics extends MovieClip {

		public function ColorPickerGraphics() {
			
			var colors:Array = [0xFF0000, 0xFFFF00, 0x00FF00, 
								0x00FFFF, 0x0000FF, 0xFF00FF, 
								0xFF0000];
			var alphas:Array = [1, 1, 1, 1, 1, 1, 1];
			var ratios:Array = [0, 42, 84, 126, 168, 210, 255];
			
			var spectrum:MovieClip = drawGradientBox(100, colors, 
													 alphas, ratios);
			addChild(spectrum);
			
			colors = [0x000000, 0x000000];
			alphas = [0, 1];
			ratios = [0, 255];
			
			var overlay:MovieClip = drawGradientBox(100, colors, 
													alphas, ratios, 
													deg2rad(90));
			addChild(overlay);
		}
		
		private function drawGradientBox(size:uint, colors:Array, 
										 alphas:Array, ratios:Array, 
										 matrixRotation:Number=0):MovieClip {
			var canvas:MovieClip = new MovieClip();
			var g:Graphics = canvas.graphics;
			
			var fill:String = GradientType.LINEAR;
			var matrix:Matrix = new Matrix();
			matrix.createGradientBox(size, size, matrixRotation, 0, 0);
			
			g.lineStyle(1, 0x000000);
			g.beginGradientFill(fill, colors, alphas, ratios, matrix);
			g.drawRect(0, 0, size, size);
			return canvas;
		}

		private function deg2rad(deg:Number):Number {
			return deg * (Math.PI/180);
		}

	}
	
}