﻿package com.learningactionscript3.sound {
	
	import flash.events.Event;
	import flash.events.SampleDataEvent;
	import flash.media.Microphone;
	import flash.media.Sound;
	import flash.media.SoundChannel;
	import flash.net.FileReference;
	import flash.utils.ByteArray;
	import com.adobe.audio.format.WAVWriter;
	
	public class RecordMicrophone {
	
		private var _mic:Microphone;
		private var _sndBytes:ByteArray;
		private var _snd:Sound = new Sound();
		private var _channel:SoundChannel = new SoundChannel();
		
		public function RecordMicrophone() {
			setupMicrophone();
		}
		
		public function setupMicrophone():void {
			_mic = Microphone.getMicrophone();
			_mic.rate = 44;
			_mic.setSilenceLevel(0);
			_mic.setUseEchoSuppression(true);
		}
		
		public function startRecording():void {
			_sndBytes = new ByteArray();
			if (!_mic.hasEventListener(SampleDataEvent.SAMPLE_DATA)) {
				_mic.addEventListener(SampleDataEvent.SAMPLE_DATA, 
									  getMicData, false, 0, true);
			}
		}
		
		private function getMicData(evt:SampleDataEvent):void {
			_sndBytes.writeBytes(evt.data);
		}
		
		public function stopRecording():void {
			_mic.removeEventListener(SampleDataEvent.SAMPLE_DATA,
									 getMicData);
		}
		
		public function playSound():void {
			if (!_snd.hasEventListener(SampleDataEvent.SAMPLE_DATA)) {
				_snd.addEventListener(SampleDataEvent.SAMPLE_DATA,
									  playbackData,
									  false, 0, true);
				_sndBytes.position = 0;
				_channel = _snd.play();
				_channel.addEventListener(Event.SOUND_COMPLETE, 
										  onPlayComplete, 
										  false, 0, true);
			}
		}
		
		private function playbackData(evt:SampleDataEvent):void {
			for (var i:int = 0; i < 8192; i++) {
				if (_sndBytes.bytesAvailable >= 4) {
					var sample:Number = _sndBytes.readFloat();
					evt.data.writeFloat(sample);
					evt.data.writeFloat(sample);
				}
			}
		}
		
		private function onPlayComplete(evt:Event):void {
			_snd.removeEventListener(SampleDataEvent.SAMPLE_DATA,
									 playbackData);
			_channel.removeEventListener(Event.SOUND_COMPLETE,
										 onPlayComplete);
		}
		
		public function stopPlaying():void {
			_channel.stop();
			onPlayComplete(null);
		}
		
		public function saveFile():void {
			if (_sndBytes.length > 0) {			
				_sndBytes.position = 0;
				
				var outputStream:ByteArray = new ByteArray();
				
				var wavWriter:WAVWriter = new WAVWriter();
				wavWriter.numOfChannels = 1;
				wavWriter.processSamples(outputStream, _sndBytes, 
										 44100, 1); 
				
				var fileRef:FileReference = new FileReference();
				fileRef.save(outputStream, "recording.wav");
			}
		}
	}
}