﻿package {

	import flash.display.Graphics;
	import flash.display.MovieClip;
	import flash.events.MouseEvent;
	import com.learningactionscript3.ui.RoundRectButton;
	import com.learningactionscript3.video.BasicVideo;

	public class BasicVideo_UI extends MovieClip {

		private var _container:MovieClip;
		private var _vidPlayer:BasicVideo;

		public function BasicVideo_UI() {
			_container = drawBackground();
			_container.x = _container.y = 20;
			addChild(_container);
			
			_vidPlayer = new BasicVideo();
			_vidPlayer.source = "nero.flv";
			_container.addChild(_vidPlayer);
			_vidPlayer.playVideo();
			
			createButton(20, "Play", playVideo);
			createButton(120, "Pause", pauseVideo);
			createButton(220, "Stop", stopVideo);
		}
		
		private function drawBackground():MovieClip {
			var sp:MovieClip = new MovieClip();
			var g:Graphics = sp.graphics;
			g.beginFill(0x000000);
			g.drawRect(0, 0, 320, 240);
			g.endFill();
			return sp;
		}
		
		private function createButton(xLoc:Number, labl:String, 
									  func:Function):void {
			var btn:RoundRectButton = 
			    new RoundRectButton(80, 20, 10, 2, 0x000099, 
									labl, 0xFFFFFF);
			btn.x = xLoc;
			btn.y = 250;
			btn.addEventListener(MouseEvent.CLICK, func, 
								 false, 0, true);
			_container.addChild(btn);
		}
		
		private function playVideo(evt:MouseEvent):void {
			_vidPlayer.playVideo();
		}
		
		private function pauseVideo(evt:MouseEvent):void {
			_vidPlayer.pauseVideo();
		}
		
		private function stopVideo(evt:MouseEvent):void {
			_vidPlayer.stopVideo();
		}
	}
}