﻿package  {

	import flash.display.Bitmap;
	import flash.display.LoaderInfo;
	import flash.display.MovieClip;
	import flash.display.Shader;
	import flash.filters.ShaderFilter;
	import flash.events.Event;
	import flash.net.URLLoaderDataFormat;
	import com.learningactionscript3.loading.CustomLoader;
	import com.learningactionscript3.loading.CustomURLLoader;
	
	public class CustomLoadBinaryExample extends MovieClip {

		private var _penguins:Bitmap;
		private var _shader:Shader;
		private var _shaderFilter:ShaderFilter;
		private var _val:Number = 0;
		private var _ldrInfo:LoaderInfo;
		private var _ldrBinary:CustomURLLoader;

		public function CustomLoadBinaryExample() {
			var jpgLoader:CustomLoader = 
			    new CustomLoader("penguins.jpg");
			_ldrInfo = jpgLoader.contentLoaderInfo;
			_ldrInfo.addEventListener(Event.COMPLETE, 
									  onImgLoaded, 
									  false, 0, true);
		}
		//load filter
		private function onImgLoaded(evt:Event):void {
			evt.target.removeEventListener(Event.COMPLETE, 
										 onImgLoaded);
			evt.target.loader.removeListeners();
			_penguins = Bitmap(evt.target.content);
			addChild(_penguins);
			
			_ldrBinary = 
			    new CustomURLLoader("squarepattern.pbj", true,
									URLLoaderDataFormat.BINARY);
			_ldrBinary.addEventListener(Event.COMPLETE,
										onFilterLoaded,
										false, 0, true);
		}
		//create Shader and ShaderFilter
		private function onFilterLoaded(evt:Event):void {
			evt.target.removeEventListener(Event.COMPLETE, 
										   onFilterLoaded);
			evt.target.removeListeners();
			_shader = new Shader(evt.target.data);
			_shaderFilter = new ShaderFilter(_shader);
			
			this.addEventListener(Event.ENTER_FRAME, onEnter,
								  false, 0, true);
		}
		//adjust filter values
		private function onEnter(evt:Event):void {
		   _penguins.filters = [_shaderFilter];
		   
		   _val++;
		   _shader.data.amount.value = [_val, _val, _val];
		   if (_val >= 50) {
			   this.removeEventListener(Event.ENTER_FRAME,
										onEnter);
		   }
		}
	}
}