﻿package com.learningactionscript3.sound {
	
	import flash.display.Graphics;
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.media.SoundMixer;
	import flash.utils.ByteArray;

	public class Waveform extends Sprite {

		private var _bytes:ByteArray = new ByteArray();
		private var _fft:Boolean;
		private var _g:Graphics;

		public function Waveform(fft:Boolean=false) {
			_fft = fft;
			_g = this.graphics;
			
			this.addEventListener(Event.ENTER_FRAME, onVisualize,
								  false, 0, true);
		}

		private function onVisualize(evt:Event):void {
			SoundMixer.computeSpectrum(_bytes, _fft);
			_g.clear();
			plotWaveform(0x009900, 50);
			plotWaveform(0xFF0000, 100);
		}
		
		private function plotWaveform(col:uint, chanBaseline:Number):void {
			_g.lineStyle(1, col);
			_g.beginFill(col, 0.5);
			_g.moveTo(0, chanBaseline);
			for (var i:Number = 0; i < 256; i++) {
				_g.lineTo(i, chanBaseline - (_bytes.readFloat() * 40));
			}
			_g.lineTo(i, chanBaseline);
			_g.endFill();
		}
	}
}