﻿package com.learningactionscript3.video {

	import flash.display.MovieClip;
	import flash.events.AsyncErrorEvent;
	import flash.events.MouseEvent;
	import flash.events.NetStatusEvent;
	import flash.net.NetConnection;
	import flash.net.NetStream;
	import flash.media.Video;

	public class BasicVideo extends MovieClip {

		private var _conn:NetConnection;
		private var _stream:NetStream;
		private var _vid:Video;
		private var _vidPlaying:Boolean;
		private var _source:String;

		public function BasicVideo(path:String="") {
			_source = path;

			_conn = new NetConnection();
			_conn.connect(null);
			_stream = new NetStream(_conn);
			
			_vid = new Video();
			_vid.attachNetStream(_stream);
			addChild(_vid);
			
			var _infoClient:Object = new Object();
			_infoClient.onMetaData = this.onMetaData;
			_infoClient.onCuePoint = this.onCuePoint;
			_stream.client = _infoClient;
			
			addEventListeners();
		}
		
		private function addEventListeners():void {
			_conn.addEventListener(NetStatusEvent.NET_STATUS,
								   onNetStatus, false, 0, true);
			_conn.addEventListener(AsyncErrorEvent.ASYNC_ERROR,
								   onAsyncError, false, 0, true);
			_stream.addEventListener(NetStatusEvent.NET_STATUS,
									 onNetStatus, false, 0, true);
			_stream.addEventListener(AsyncErrorEvent.ASYNC_ERROR,
									 onAsyncError, false, 0, true);
		}
		
		private function onAsyncError(evt:AsyncErrorEvent):void {
			trace(evt.text);
		}
		
		private function onNetStatus(evt:NetStatusEvent):void {
			trace(evt.info.level + ": " + evt.info.code);
			if (evt.info.code == "NetStream.Play.Start") {
				_vidPlaying = true;
			} else if (evt.info.code == "NetStream.Play.Stop") {
				_vidPlaying = false;
			}
		}
		
		private function onMetaData(info:Object):void {
			trace("MetaData duration:", info.duration);
		}
		
		private function onCuePoint(info:Object):void {
			trace("Cue point time:", info.time);
			trace("Cue point type:", info.type);
			trace("Cue point name:", info.name);
			for (var prop in info.parameters) {
				trace("Cue point parameter " + prop + ": " + info.parameters[prop]);
			}
		}
		
		public function playVideo(evt:MouseEvent=null):void {
			if (_vidPlaying) {
				_stream.resume();
			} else {
				_stream.play(_source);
			}
			_vidPlaying = true;
		}
		
		public function pauseVideo(evt:MouseEvent=null):void {
			_stream.togglePause();
		}
		
		public function stopVideo(evt:MouseEvent=null):void {
			_stream.close();
			_vid.clear();
			_vidPlaying = false;
		}
		
		public function set source(path:String):void {
			_source = path;
		}
		
		public function get source():String {
			return _source;
		}
	}
}