﻿package com.learningactionscript3.loading {

    import flash.events.Event;
    import flash.events.HTTPStatusEvent;
    import flash.events.IOErrorEvent;
    import flash.events.ProgressEvent;
    import flash.events.SecurityErrorEvent;			
    import flash.net.URLLoader;
    import flash.net.URLRequest;
    
	public class CustomURLLoader extends URLLoader {
		
		private var _path:String;
		private var _verbose:Boolean;
		private var _loadedPercent:Number = 0;
		
		function CustomURLLoader(path:String=null, 
								 verbose:Boolean=false,
								 format:String="text") {
			_path = path;
			_verbose = verbose;	
			this.dataFormat = format;
			
			addListeners();
			
			if (path != null) {
				try {
					this.load(new URLRequest(path));
				} catch (err:Error) {
					trace("Cannot load", _path, err.message);
				}
			}
		}
		
		private function addListeners():void {
            this.addEventListener(Event.OPEN,
								  onOpen, false, 0, true);
            this.addEventListener(ProgressEvent.PROGRESS,
								  onProgress, false, 0, true);
            this.addEventListener(HTTPStatusEvent.HTTP_STATUS,
								  onStatusEvent,
								  false, 0, true);
            this.addEventListener(Event.COMPLETE,
								  onComplete, false, 0, true);
			this.addEventListener(IOErrorEvent.IO_ERROR,
								  onIOError, false, 0, true);
            this.addEventListener(SecurityErrorEvent.SECURITY_ERROR,
								  onSecError,
								  false, 0, true);
		}
		
		public function removeListeners():void {
			this.removeEventListener(Event.OPEN, onOpen);
            this.removeEventListener(ProgressEvent.PROGRESS,
									 onProgress);
            this.removeEventListener(HTTPStatusEvent.HTTP_STATUS,
									 onStatusEvent);
            this.removeEventListener(Event.COMPLETE, onComplete);
			this.removeEventListener(IOErrorEvent.IO_ERROR,
									 onIOError);
            this.removeEventListener(SecurityErrorEvent.SECURITY_ERROR,
									 onSecError);
		}
		
		private function onOpen(evt:Event):void {
            if (_verbose) { trace("Loading begun:", _path); }
        }

        private function onProgress(evt:ProgressEvent):void {
			_loadedPercent = evt.bytesLoaded/evt.bytesTotal;
			if (_verbose) { 
				trace("Loading", _path, 
					  "-- progress (0-1):", _loadedPercent);
			}
        }
		
        private function onStatusEvent(evt:HTTPStatusEvent):void {
            if (_verbose) { trace("HTTP status:", evt.status); }
        }
		
        private function onComplete(evt:Event):void {			
			if (_verbose) { trace("Loading complete:", _path); }
        }
		
        private function onSecError(evt:SecurityErrorEvent):void {
            trace("Security error:", evt.text);
        }

		private function onIOError(evt:IOErrorEvent):void {
			trace("Loading error:", evt.text);
		}
		
		public function get percentLoaded():Number {
			return _loadedPercent;
		}
		
		public function set verbose(bool:Boolean):void {
			_verbose = bool;
		}
	}
}