﻿package com.learningactionscript3.ui {

	import flash.display.Graphics;
	import flash.display.MovieClip;
	import flash.events.Event;
	import flash.events.MouseEvent;
	import flash.geom.Matrix;
	import flash.net.URLRequest;
	import flash.text.TextField;
	import com.greensock.TweenLite;
	import com.greensock.plugins.TweenPlugin;
	import com.greensock.plugins.VisiblePlugin;
	import com.greensock.plugins.ColorTransformPlugin;
	import com.learningactionscript3.ui.MenuButtonMain;
	import com.learningactionscript3.ui.MenuButtonSub;

	public class NavigationBarXML extends MovieClip {

		private var _app:MovieClip;
		private var _navData:XMLList;
		private var _subMenu:MovieClip;
		//constructor
		public function NavigationBarXML(app:MovieClip, 
										 navData:XMLList) {
			_app = app;
			_navData = navData;
			
			addMenus();
			
			var line:MovieClip = new MovieClip();
			var g:Graphics = line.graphics;
			g.beginFill(0x000000);
			g.drawRect(0, 0, _app.stage.stageWidth, 4);
			g.endFill();
			line.y = 100;
			line.mouseEnabled = false;
			this.addChild(line);
			
			TweenPlugin.activate([VisiblePlugin]);
			TweenPlugin.activate([ColorTransformPlugin]);
		}
		//building the menus
		private function addMenus():void {
			var mainButtonLength:uint = _navData.button.length();
			for (var i:int; i < mainButtonLength; i++) {
				var buttonXML:XML = _navData.button[i];
				
				//main button
				var mainBtn:MovieClip = 
				    new MenuButtonMain(buttonXML.@label);
				mainBtn.x = 20 + i * (mainBtn.width + 2);
				mainBtn.y = 75;
				mainBtn.addEventListener(MouseEvent.MOUSE_OVER, 
										 onMainBtnOver, 
										 false, 0, true);
				mainBtn.addEventListener(MouseEvent.MOUSE_OUT, 
										 onMainBtnOut, 
										 false, 0, true);
				this.addChild(mainBtn);
				//sub menu
				var subMenu:MovieClip = new MovieClip();
				subMenu.y = mainBtn.height + 2;
				subMenu.visible = false;
				mainBtn.addChild(subMenu);
				
				//sub buttons
				var subButtonLength:uint = buttonXML.project.length();
				for (var j:int = 0; j < subButtonLength; j++) {
					var projectNode:XML = buttonXML.project[j];
					var subButton:MovieClip = 
					    new MenuButtonSub(projectNode.@label);
					subButton.projectPath = projectNode.@path;
					subButton.projectDescription = projectNode;
					subButton.y = ((subButton.height) * j);
					subButton.addEventListener(MouseEvent.CLICK, 
											   onSubBtnClick,
											   false, 0, true);
					subMenu.addChild(subButton);
				}
			}
		}
		//menu button mouse roll behavior: appearance
		private function onMainBtnOver(evt:MouseEvent):void {
			var mainBtn:MovieClip = MovieClip(evt.currentTarget);
			_subMenu = mainBtn.getChildAt(2);
			_subMenu.visible = true;
			TweenLite.to(_subMenu, 0.25, {alpha:1}); 
		}
		
		private function onMainBtnOut(evt:MouseEvent):void {
			if (!(evt.relatedObject is MenuButtonSub)) {
				TweenLite.to(_subMenu, 0.25, {alpha:0, visible:false});
			}
		}
		//menu button click behavior: loading
		private function onSubBtnClick(evt:MouseEvent):void {
			var subBtn:MovieClip = MovieClip(evt.target);
			var path:String = subBtn.projectPath;
			var description:String = subBtn.projectDescription;
			_app.assetLoader.unload(); //when targeting FP 9
			//_app.assetLoader.unloadAndStop(); //when targeting FP 10
			_app.assetLoader.load(new URLRequest(path));
		}
	}
}